
/*  A Bison parser, made from math.y
 with Bison version Bison version A2.3 (Andrew Consortium)
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	NUM	258
#define	VAR	259
#define	FNCT	260
#define	DOUBLEEQL	261
#define	NEG	263

#line 1 "math.y"

#define SW_VERSION "X01-04"
#pragma module MATH SW_VERSION

/*
**
** Copyright 2009 James F. Duff.  ALL RIGHTS RESERVED.
**
** License Terms and Conditions:
**
** You may freely copy and distribute verbatim copies of this software package
** as you receive it, in any medium, provided that you conspicuously and
** appropriately publish on each copy this copyright notice and
** disclaimer of warranty; keep intact all the notices that refer to these
** license terms and conditions and to the absence of any warranty; and give
** any other recipients of the software package a copy of these license 
** terms and conditions along with the software.
**
** You may modify the software for your own use, but you MAY NOT distribute
** modified copies of the software.
**
** By copying or distributing the software package you indicate your
** acceptance of this license to do so, and all its terms and conditions.
**
** Each time you redistribute the software package the recipient
** automatically receives a license from the original licensor to copy,
** distribute or modify the software package subject to these terms and
** conditions. You may not impose any further restrictions on the recipients'
** exercise of the rights granted herein.
**
** BECAUSE THE SOFTWARE IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
** FOR THE SOFTWARE, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN
** OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDER PROVIDE THE SOFTWARE
** "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,
** INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
** AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY
** AND PERFORMANCE OF THE SOFTWARE IS WITH YOU.  SHOULD THE SOFTWARE PROVE
** DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
** CORRECTION.
**
** YOU WARRANT THAT IN NO EVENT WILL THE COPYRIGHT HOLDER BE LIABLE TO
** YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR
** CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE
** SOFTWARE (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF THE
** SOFTWARE TO OPERATE WITH ANY OTHER SOFTWARE, FIRMWARE OR HARDWARE), EVEN IF
** SUCH HOLDER HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
**
** NO TITLE TO AND OWNERSHIP OF THE SOFTWARE PACKAGE IS HEREBY TRANSFERRED.
**
** Send suggestions, bug reports, money ;-) to jim@eight-cubed.com
**
** Now that's out of the way, on with the code...
**
**--
*/

/*
**++
**
**  MODULE DESCRIPTION:
**
**	Support floating point functions from the DCL command line.  Allow
**	full infix calculations with the single argument C maths functions
**	all available.  Allow variables on the RHS to be read from DCL
**	symbols.  Allow the LHS to be set as a DCL symbol, either local or
**	global depending on the = or == signs.
**
**  AUTHORS:
**
**      James F. Duff
**
**  CREATION DATE:
**
**	01-Apr-2009
**
**  MODIFICATION HISTORY:
**
**      X01-00	    Jim Duff	    01-Apr-2009
**	Original version of module
**
**	X01-01	    Jim Duff	    05-Apr-2009
**	Handle the condition where the expression doesn't have a RHS.
**
**	X01-02	    Jim Duff	    07-Sep-2009
**	Oops, if the LHS has a DCL variable with an existing string value in
**	it, the code complained that the value was not a floating point number
**	if it wasn't.  This shouldn't happen as the variable on the LHS will
**	just be overwritten anyway.  Let's do proper VMS error messages while
**	we're in here.
**
**	X01-03	    Jim Duff	    08-Feb-2010
**	Do some code hygiene.
**
**	X01-04	    Jim Duff	    28-Jun-2010
**	Heh.  DCL allows the inclusion of the dollar and underscore characters
**	in symbol names.  Make this utility behave the same way.
**
**--
*/

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#ifdef __ALPHA
#  include <builtins.h>
#endif

/*
** Required for pow()
*/
#include <math.h>

#define YYERROR_VERBOSE 1
#define OP_PLUS 0
#define OP_MINUS 1
#define OP_MULT 2
#define OP_DIV 3

/*
** Function type.
*/
typedef double (*func_t) (double);

/*
** Symbol definition
*/
struct symrec {
    struct symrec *next;
    char *name; 
    int type;
    union {
	double var;
	func_t fnctptr;
    } value;
};

typedef struct symrec symrec;

/*
** Global declaration.
*/
static int gbl = FALSE;
static int rhs = FALSE;

/*
** Error messages
*/
#pragma extern_model save
#pragma extern_model globalvalue
extern int MATH_ERROR;
extern int MATH_UNDEF;
extern int MATH_ILLCHAR;
extern int MATH_UNPREDICT;
extern int MATH_INVARG;
#pragma extern_model restore

/*
** Forward declarations
*/
static int yylex (void);
static void yyerror (char const *);
static void set_sym (double);
static double do_math (char *, double (*)(double), double);
static double do_op (double, double, int);
static symrec *putsym (char *, int);
static symrec *getsym (char const *);


#line 171 "math.y"
typedef union {
    double val;
    symrec *tptr;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		30
#define	YYFLAG		-32768
#define	YYNTBASE	17

#define YYTRANSLATE(x) ((unsigned)(x) <= 263 ? yytranslate[x] : 20)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    15,
    16,    11,    10,     2,     9,     2,    12,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     8,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,    14,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,    13
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     3,     5,     7,     9,    13,    17,    22,    26,
    30,    34,    38,    41,    45
};

static const short yyrhs[] = {    -1,
    18,     0,    19,     0,     3,     0,     4,     0,     4,     8,
    19,     0,     4,     6,    19,     0,     5,    15,    19,    16,
     0,    19,    10,    19,     0,    19,     9,    19,     0,    19,
    11,    19,     0,    19,    12,    19,     0,     9,    19,     0,
    19,    14,    19,     0,    15,    19,    16,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   189,   190,   193,   202,   203,   204,   207,   210,   212,   213,
   214,   215,   216,   217,   218
};
#endif

#define YYNTOKENS 17
#define YYNNTS 3
#define YYNRULES 15
#define YYNSTATES 31
#define YYMAXUTOK 263

static const char * const yytname[] = {   "$","error","$illegal.","NUM","VAR",
"FNCT","DOUBLEEQL","\"==\"","'='","'-'","'+'","'*'","'/'","NEG","'^'","'('",
"')'","input","line","exp", NULL
};
static const short yytoknum[] = { 0,
   256,   257,   258,   259,   260,   261,   262,    61,    45,    43,
    42,    47,   263,    94,    40,    41,     0
};

static const short yyr1[] = {     0,
    17,    17,    18,    19,    19,    19,    19,    19,    19,    19,
    19,    19,    19,    19,    19
};

static const short yyr2[] = {     0,
     0,     1,     1,     1,     1,     3,     3,     4,     3,     3,
     3,     3,     2,     3,     3
};

static const short yydefact[] = {     1,
     4,     5,     0,     0,     0,     2,     3,     0,     0,     0,
    13,     0,     0,     0,     0,     0,     0,     7,     6,     0,
    15,    10,     9,    11,    12,    14,     8,     0,     0,     0
};

static const short yydefgoto[] = {    28,
     6,     7
};

static const short yypact[] = {    11,
-32768,    28,   -13,    11,    11,-32768,    29,    11,    11,    11,
   -11,    13,    11,    11,    11,    11,    11,    29,    29,    21,
-32768,     7,     7,   -11,   -11,   -11,-32768,     8,    17,-32768
};

static const short yypgoto[] = {-32768,
-32768,    -4
};


#define	YYLAST		43


static const short yytable[] = {    11,
    12,    10,    17,    18,    19,    20,     0,    29,    22,    23,
    24,    25,    26,     1,     2,     3,    30,    15,    16,     4,
    17,    13,    14,    15,    16,     5,    17,     0,    21,    13,
    14,    15,    16,     8,    17,     9,    27,    13,    14,    15,
    16,     0,    17
};

static const short yycheck[] = {     4,
     5,    15,    14,     8,     9,    10,    -1,     0,    13,    14,
    15,    16,    17,     3,     4,     5,     0,    11,    12,     9,
    14,     9,    10,    11,    12,    15,    14,    -1,    16,     9,
    10,    11,    12,     6,    14,     8,    16,     9,    10,    11,
    12,    -1,    14
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Bob Corbett and Richard Stallman

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */


#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#elif __VMS
#include <stdlib.h>
#include <string.h>
#define alloca malloc
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#define YYLEX		yylex(&yylval, &yylloc)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif


#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_bcopy(FROM,TO,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif


#line 184 "bison.simple"
int
yyparse(void)
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages
enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated)
token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers
*/
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them
elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into
memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_bcopy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_bcopy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_bcopy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 3:
#line 193 "math.y"
{ if (rhs) {
					set_sym (yyvsp[0].val);
				  } else {
					(void)fprintf (stderr,
						       "parse error");
				  }
				;
    break;}
case 4:
#line 202 "math.y"
{ yyval.val = yyvsp[0].val;				;
    break;}
case 5:
#line 203 "math.y"
{ yyval.val = yyvsp[0].tptr->value.var;			;
    break;}
case 6:
#line 204 "math.y"
{ yyval.val = yyvsp[0].val;
				  yyvsp[-2].tptr->value.var = yyvsp[0].val;
				  gbl = FALSE;				;
    break;}
case 7:
#line 207 "math.y"
{ yyval.val = yyvsp[0].val;
				  yyvsp[-2].tptr->value.var = yyvsp[0].val;
				  gbl = TRUE;				;
    break;}
case 8:
#line 210 "math.y"
{ yyval.val = do_math (yyvsp[-3].tptr->name,
						yyvsp[-3].tptr->value.fnctptr, yyvsp[-1].val);	;
    break;}
case 9:
#line 212 "math.y"
{ yyval.val = do_op (yyvsp[-2].val, yyvsp[0].val, OP_PLUS);		;
    break;}
case 10:
#line 213 "math.y"
{ yyval.val = do_op (yyvsp[-2].val, yyvsp[0].val, OP_MINUS);	;
    break;}
case 11:
#line 214 "math.y"
{ yyval.val = do_op (yyvsp[-2].val, yyvsp[0].val, OP_MULT);		;
    break;}
case 12:
#line 215 "math.y"
{ yyval.val = do_op (yyvsp[-2].val, yyvsp[0].val, OP_DIV);		;
    break;}
case 13:
#line 216 "math.y"
{ yyval.val = -yyvsp[0].val;				;
    break;}
case 14:
#line 217 "math.y"
{ yyval.val = pow (yyvsp[-2].val, yyvsp[0].val);			;
    break;}
case 15:
#line 218 "math.y"
{ yyval.val = yyvsp[-1].val;				;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 465 "bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      (void)strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			(void)strcat(msg, count == 0 ? ", expecting `" : " or `");
			(void)strcat(msg, yytname[x]);
			(void)strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error,
discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar,
yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error
token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok. 
Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token
*/

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 221 "math.y"


#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <ssdef.h>
#include <stsdef.h>
#include <string.h>
#include <descrip.h>
#include <libdef.h>
#include <libclidef.h>
#include <lib$routines.h>
#include <starlet.h>

#define errchk_sig(arg) if (!$VMS_STATUS_SUCCESS(arg)) (void)lib$signal(arg);

struct init {
    char *fname;
    double (*fnct) (double);
};

/*
** Global variables
*/

static char dcl_target[255];
static struct dsc$descriptor_s dcl_target_d = { 0,
					        DSC$K_DTYPE_T,
					        DSC$K_CLASS_S,
					        dcl_target };

static char com_command[4096];

/*
** The symbol table: a linked list of symrecs
*/
static symrec *sym_table;


/******************************************************************************/
static void yyerror (char const *s) {
/*
** Standard Bison error reporting routine.  Just write out the message.
*/

    (void)lib$signal (MATH_ERROR, 1, s);
}


/******************************************************************************/
static void init_table (void) {
/*
** Put arithmetic functions in table.
*/
static struct init arith_fncts[] =
{ "SIN", sin,
  "COS", cos,
  "TAN", tan,
  "ASIN", asin,
  "ACOS", acos,
  "ATAN", atan,
  "SINH", sinh,
  "COSH", cosh,
  "TANH", tanh,
  "LN", log,
  "LOG", log10,
  "EXP", exp,
  "SQRT", sqrt,
  "CEIL", ceil,
  "FLOOR", floor,
  "FABS", fabs,
  NULL, NULL
};

int i;
symrec *ptr;

    for (i = 0; arith_fncts[i].fname != NULL; i++) {
	ptr = putsym (arith_fncts[i].fname, FNCT);
	ptr->value.fnctptr = arith_fncts[i].fnct;
    }
}


/******************************************************************************/
static symrec *putsym (char *sym_name, int sym_type) {
/*
** Add a symbol to the symbol table.  It's either a function symbol (that is,
** one of our reserved words for functions) or a variable.  If the variable
** is on the right hand side of the equals sign, the variable can potentially
** be an existant DCL local or global symbol.  If the variable is on the LHS,
** the symbol name will eventually be used to create/overwrite a DCL symbol.
*/
symrec *ptr;

int i;
int r0_status;

char buffer[255];

struct dsc$descriptor_d name_d = { 0, DSC$K_DTYPE_T, DSC$K_CLASS_S, NULL };
struct dsc$descriptor_d buffer_d = { 0, DSC$K_DTYPE_T, DSC$K_CLASS_S, NULL };

    ptr = malloc (sizeof (symrec));
    if (ptr == NULL) {
	(void)fprintf (stderr, "Could not allocate a symrec ptr!\n");
	(void)lib$signal (SS$_INSFMEM);
    }
    ptr->name = malloc (strlen (sym_name) + 1);
    if (ptr->name == NULL) {
	(void)fprintf (stderr, "Could not allocate a symrec ptr->name!\n");
	(void)lib$signal (SS$_INSFMEM);
    }
    (void)strcpy (ptr->name,sym_name);
    ptr->type = sym_type;
    /*
    ** Set value to 0 even if fctn.
    */
    ptr->value.var = 0;

    if (sym_type == VAR) {
	if (!rhs) {
	    /*
	    ** A variable on the LHS.  Store its name for later use to create
	    ** or overwrite a DCL symbol.
	    */
	    (void)strcpy (dcl_target, sym_name);
	    dcl_target_d.dsc$w_length = strlen (sym_name);
	}

	/*
	** Let's see if the symbol we are storing is a DCL symbol already.  If
	** so, store the value away.  If we are on the RHS, a non-existant DCL
	** symbol reference is an error.
	*/
	name_d.dsc$w_length = strlen (sym_name);
	name_d.dsc$a_pointer = sym_name;
	buffer_d.dsc$w_length = sizeof (buffer);
	buffer_d.dsc$a_pointer = buffer;
	r0_status = lib$get_symbol (&name_d,
				    &buffer_d,
				    &buffer_d.dsc$w_length,
				    0);
	if (r0_status == LIB$_NOSUCHSYM) {
	    if (rhs) {
		(void)lib$signal (MATH_UNDEF, 1, sym_name);
	        exit (EXIT_FAILURE);
	    }
        } else {
	    errchk_sig (r0_status);

	    if (rhs) {
	        /*
	        ** Get the DCL's value into a double.
	        */
	        buffer[buffer_d.dsc$w_length] = '\0';
	        (void)sscanf (buffer, "%lf", &ptr->value.var);
	        for (i = 0; i < strlen (buffer); i++) {
	            if (!isdigit (buffer[i]) &&
		        buffer[i] != '.' &&
		        buffer[i] != '-') {
			(void)lib$signal (MATH_ILLCHAR, 1, sym_name);
		        break;
	            }
		}
	    } else {
		ptr->value.var = 0.0;
	    }
        }
    }
    ptr->next = sym_table;
    sym_table = ptr;
    return ptr;
}


/******************************************************************************/
static symrec *getsym (char const *sym_name) {
/*
** See if a symbol exists in the symbol table and return its address if so.
*/
symrec *ptr;

    ptr = sym_table;
    while (ptr != NULL) {
	if (strcmp (ptr->name, sym_name) == 0) {
	    break;
	}
        ptr = ptr->next;
    }
    return ptr;
}


/******************************************************************************/
static int yylex (void) {
/*
** Bison lexer.  Read the command and return tokens and types.
*/

char c;
static char *p = com_command;

    c = *p++;

    if (c == '\0') {
	return 0;
    }

    /*
    ** Char starts a number => parse the number.
    */
    if (c == '.' || isdigit (c)) {
	--p;
	(void)sscanf (p, "%lf", &yylval.val);
	while (c == '.' || isdigit (c)) {
	    c = *p++;
	} 
	--p;
	return NUM;
    }

    /*
    ** Char starts an identifier => read the name.
    */
    if (isalpha (c) || c == '$' || c == '_') {
	symrec *s;
	static char *symbuf = NULL;
	static int length = 0;
	int i;

	/*
	** Initially make the buffer long enough for a 40-character symbol
	** name.
	*/
	if (length == 0) {
	    length = 40;
	    symbuf = malloc (length + 1);
	    if (symbuf == NULL) {
		(void)fprintf (stderr, "Could not allocate a symbuf!\n");
		(void)lib$signal (SS$_INSFMEM);
	    }
	}

	i = 0;
	do {
	    /*
	    ** If buffer is full, make it bigger.
	    */
	    if (i == length) {
		length *= 2;
		symbuf = realloc (symbuf, length + 1);
	        if (symbuf == NULL) {
		    (void)fprintf (stderr, "Could not reallocate a symbuf!\n");
		    (void)lib$signal (SS$_INSFMEM);
	        }
	    }
	    /*
	    ** Add this character to the buffer.
	    */
	    symbuf[i++] = c;

	    /*
	    ** Get another character.
	    */
	    c = *p++;
	} while (isalnum (c) || c == '$' || c == '_');

	--p;;

	symbuf[i] = '\0';
	s = getsym (symbuf);
	if (s == NULL) {
	    s = putsym (symbuf, VAR);
	}

	yylval.tptr = s;
	return s->type;
    }

    if (c == '=') {
	/*
	** If the character is an equals sign, we are now on the RHS.
	** If the equals sign is immediately followed by another equals sign,
	** tell the parser we saw a DOUBLEEQL token.
	*/
	rhs = TRUE;
	if (*p == '=') {
	    p++;
	    return DOUBLEEQL;
	}
    }

    /*
    ** Any other character is a token by itself.
    */
    return c;
}



/******************************************************************************/
static void set_sym (double value) {
/*
** Set a DCL symbol to a string representation of the double arg.
*/

int r0_status;
static int global_flag = LIB$K_CLI_GLOBAL_SYM;
static int local_flag = LIB$K_CLI_LOCAL_SYM;
static char dcl_str[255];
static struct dsc$descriptor_d dcl_str_d = { 0,
				             DSC$K_DTYPE_T,
				             DSC$K_CLASS_S,
				             dcl_str };

    dcl_str_d.dsc$w_length = sprintf (dcl_str, "%.10f", value);
    r0_status = lib$set_symbol (&dcl_target_d,
				&dcl_str_d,
				gbl ? &global_flag : &local_flag);
    errchk_sig (r0_status);
}


/******************************************************************************/
static int handler_unpredict (int sigargs[], int mechargs[]) {

static int r0_status;
static int return_val;
static int ss$_unwind = SS$_UNWIND;

    r0_status = lib$match_cond (&sigargs[1],
				&ss$_unwind,
				&MATH_UNPREDICT);
    switch (r0_status) {
	case 0:
	    return_val = SS$_RESIGNAL;
	    break;
	case 1:
	    return_val = SS$_UNWIND;
	    break;
	default:
	    /*
	    ** It's one of our messages.  Just output the text.
	    */
	    sigargs[0] -= 2;
            (void)sys$putmsg (sigargs, 0, 0, 0);
	    return_val = SS$_CONTINUE;
	    break;
    }
    return return_val;
}


/******************************************************************************/
static int handler_fpe (int sigargs[], int mechargs[]) {
/*
** Let's ensure if we ever get a floating point error signalled, we deal
** with it.
*/
static int r0_status;
static int return_val;
static int i;
static int ss$_unwind = SS$_UNWIND;
static int ss$_hparith = SS$_HPARITH;
static int ss$_fltdiv = SS$_FLTDIV;
static int ss$_fltund = SS$_FLTUND;
static int ss$_fltovf = SS$_FLTOVF;
static int ss$_fltine = SS$_FLTINE;
static char *msgs[] = {
    "Complete",
    "Divide by zero error",
    "Floating point exponent overflow",
    "Floating point exponent underflow",
    "Floating point result not exact" };

    /*
    ** Yes, this handler can signal new conditions.
    */
    (void)lib$establish (handler_unpredict);

    r0_status = lib$match_cond (&sigargs[1],
				&ss$_unwind,
				&ss$_hparith,
				&ss$_fltdiv,
				&ss$_fltovf,
				&ss$_fltund,
				&ss$_fltine,
				&MATH_ERROR,
				&MATH_UNDEF,
				&MATH_ILLCHAR,
				&MATH_INVARG);
    switch (r0_status) {
	case 0:
	    return_val = SS$_RESIGNAL;
	    break;
	case 1:
	    return_val = SS$_UNWIND;
	    break;
	case 2:
	    /*
	    ** For HPARITH errors on Alpha, decode the real error.
	    */
	    for (i = 1; i < 7; i++) {
		if ((sigargs[4] & (1<<i)) != 0) {
		    break;
		}
	    }
	    (void)lib$signal (MATH_UNPREDICT, 1, msgs[i-1]);
	    return_val = SS$_CONTINUE;
	    break;
	case 3:
	case 4:
	case 5:
	case 6:
	    (void)lib$signal (MATH_UNPREDICT, 1, msgs[r0_status - 2]);
	    return_val = SS$_CONTINUE;
	    break;
	case 7:
	case 8:
	case 9:
	case 10:
	    /*
	    ** It's one of our messages.  Just output the text.
	    */
	    sigargs[0] -= 2;
            (void)sys$putmsg (sigargs, 0, 0, 0);
	    return_val = SS$_CONTINUE;
	    break;
	default:
	    return_val = SS$_RESIGNAL;
	    break;
    }
    return return_val;
}


/******************************************************************************/
static double do_math (char *fname, double (*fnct)(double), double arg) {
/*
** Perform a single argument C math function.
*/
static double temp;

    temp = fnct (arg);
    if (errno != 0) {
	(void)lib$signal (MATH_INVARG, 1, fname);
	exit (EXIT_FAILURE);
    }
    return temp;
}


/******************************************************************************/
static double do_op (double a, double b, int op) {
/*
** This does the normal maths ops.  On alpha, we need to make the operations
** synchronous, hence this routine and all the trapb instructions.
*/
static double result;

    switch (op) {
	case OP_PLUS:
	    result = a + b;
#ifdef __ALPHA
	    __TRAPB ();
#endif /* __ALPHA */
	    break;
	case OP_MINUS:
	    result = a - b;
#ifdef __ALPHA
	    __TRAPB ();
#endif /* __ALPHA */
	    break;
	case OP_MULT:
	    result = a * b;
#ifdef __ALPHA
	    __TRAPB ();
#endif /* __ALPHA */
	    break;
	case OP_DIV:
	    result = a / b;
#ifdef __ALPHA
	    __TRAPB ();
#endif /* __ALPHA */
	    break;
	default:
	    (void)fprintf (stderr, "Internal operations error!\n");
	    exit (EXIT_FAILURE);
	    break;
    }
    return result;
}


/******************************************************************************/
int main (int argc, char *argv[]) {

static int i;
static int j;
static int r0_status;
static char command[4096];
static struct dsc$descriptor_s command_d = { sizeof (command),
					     DSC$K_DTYPE_T,
					     DSC$K_CLASS_S,
					     command };

    /*
    ** Get the foreign command line.
    */
    r0_status = lib$get_foreign (&command_d,
				 0,
				 &command_d.dsc$w_length);
    errchk_sig (r0_status);

    /*
    ** Remove spaces so the lexer is easier to write.
    */
    for (i = j = 0; i < command_d.dsc$w_length; i++) {
	if (!isspace (command[i])) {
	    com_command[j++] = toupper (command[i]);
	}
    }
    com_command[j] = '\0';

    if (j > 0) {
        init_table ();

	(void)lib$establish (handler_fpe);

        (void)yyparse ();
    } else {
	(void)fprintf (stderr,
		       "MATH version " SW_VERSION "\n\n"
                       "Usage: MATH symbol =[=] mathamatical formula\n"
		       "\twhere symbol is a DCL symbol to be created/overwritten\n"
		       "\tand mathamatical formula is a standard infix calculation\n"
		       "\n"
		       "\tExamples:\n\n"
		       "\t\tMATH a = 2\n"
		       "\t\tMATH b = (a + 1) * 3\n"
		       "\t\tMATH c == sqrt (b)\n"
		       "\t\tMATH d'counter' = counter * 100 + 0.5\n\n"
		       "\tThe right hand side supports these function:\n\n"
		       "\t\tCOS, SIN, TAN, ACOS, ASIN, ATAN, COSH, SINH, TANH\n"
		       "\t\tLN, LOG, EXP, SQRT, CEIL, FLOOR, and FABS.\n\n"
		       "\tThe standard maths symbols are used: +, -, *, /, and ^\n"
		       "\tDCL symbols may appear on the RHS, as long as they\n"
		       "\texist and contain a floating point string.\n\n"
		       "\tAll normal DCL symbol subsitution is honoured.\n");
    }
}
